#include <iostream>
#include <stdio.h>
#include <cmath>
#include <string.h>
#include <time.h>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
typedef long double Double;

#define INF 999999999
#define DV 2

struct color
{
    int r,g,b;
};

struct rect
{
    int x,y;
    color c;
    color need;
    Double diff;
};

struct move
{
    int x1,y1,x2,y2,h,w;
};

color pic[201][201];
color goal[201][201];
color inp[201][201];
int n,m,k;
int AM=20000;

rect rects[40001];
int L=0;

bool taken[201][201];
bool TFO[202][202];
int component[201][201];
int component_g[201][201];
int ctr=0;
color pattern;
int TIME_LIMIT=14*CLOCKS_PER_SEC;

vector<move> Moves;
vector<move> BestMoves;

queue< pair<int,int> > q;

bool TimeIsOK()
{
    return clock()<TIME_LIMIT;
}

int Sq(int a)
{
    return a*a;
}

int IntD(color a,color b)
{
    return Sq(a.r-b.r) + Sq(a.g-b.g) + Sq(a.b-b.b);
}

Double DoubleD(color a,color b)
{
    return sqrt( (Double)IntD(a,b) );
}

color Mix(color a,color b)
{
    color c;

    c.r=(a.r+b.r)/2;
    c.g=(a.g+b.g)/2;
    c.b=(a.b+b.b)/2;

    return c;
}

/// Components discovery

bool OK(int x,int y)
{
    if (x<1 || y<1 || x>n || y>m || TFO[x][y])
    return false;
    if ( IntD(pic[x][y],pattern)>AM )
    return false;
    return true;
}

void Add(int x,int y)
{
    TFO[x][y]=true;
    q.push( make_pair(x,y) );
    component[x][y]=ctr;
    return;
}

void MarkBFS(int x,int y)
{
    pair<int,int> v;
    int i;

    while(!q.empty())
    q.pop();

    Add(x,y);

    while(!q.empty())
    {
        v=q.front();
        q.pop();

        if (OK(v.first+1,v.second))
        Add(v.first+1,v.second);

        if (OK(v.first-1,v.second))
        Add(v.first-1,v.second);

        if (OK(v.first,v.second+1))
        Add(v.first,v.second+1);

        if (OK(v.first,v.second-1))
        Add(v.first,v.second-1);
    }

    return;
}

void MarkDFS(int x,int y)
{
    if (TFO[x][y] || x<1 || y<1 || x>n || y>m)
    return;

    if ( IntD(pic[x][y],pattern)>AM )
    {
        return;
    }

    TFO[x][y]=true;
    component[x][y]=ctr;

    MarkDFS(x+1,y);
    MarkDFS(x-1,y);
    MarkDFS(x,y-1);
    MarkDFS(x,y+1);

    return;
}

///

bool OK2(int x,int y)
{
    if (x<1 || y<1 || x>n || y>m || TFO[x][y])
    return false;
    if ( IntD(goal[x][y],pattern)>AM )
    return false;
    return true;
}

void Add2(int x,int y)
{
    TFO[x][y]=true;
    q.push( make_pair(x,y) );
    component_g[x][y]=ctr;
    return;
}

void MarkBFS2(int x,int y)
{
    pair<int,int> v;
    int i;

    while(!q.empty())
    q.pop();

    Add2(x,y);

    while(!q.empty())
    {
        v=q.front();
        q.pop();

        if (OK2(v.first+1,v.second))
        Add2(v.first+1,v.second);

        if (OK2(v.first-1,v.second))
        Add2(v.first-1,v.second);

        if (OK2(v.first,v.second+1))
        Add2(v.first,v.second+1);

        if (OK2(v.first,v.second-1))
        Add2(v.first,v.second-1);
    }

    return;
}

void MarkDFS2(int x,int y)
{
    if (TFO[x][y] || x<1 || y<1 || x>n || y>m)
    return;

    if ( IntD(goal[x][y],pattern)>AM )
    {
        return;
    }

    TFO[x][y]=true;
    component_g[x][y]=ctr;

    MarkDFS2(x+1,y);
    MarkDFS2(x-1,y);
    MarkDFS2(x,y-1);
    MarkDFS2(x,y+1);

    return;
}

///

///Slow functions TO BE IMPROVED

bool SameColor(int x1,int y1,int x2,int y2)
{
    int i,j;

    for (i=x1;i<=x2;i++)
    {
        for (j=y1;j<=y2;j++)
        {
            if (component[i][j]!=component[x1][y1] || component_g[i][j]!=component_g[x1][y1])
            return false;
        }
    }

    return true;
}

color FindColor(int x1,int y1,int x2,int y2)
{
    int i,j;
    int sumR=0,sumG=0,sumB=0;
    color ret;
    int sz=(x2-x1+1)*(y2-y1+1);

    for (i=x1;i<=x2;i++)
    {
        for (j=y1;j<=y2;j++)
        {
            sumR+=pic[i][j].r;
            sumG+=pic[i][j].g;
            sumB+=pic[i][j].b;
        }
    }

    ret.r=sumR/sz;
    ret.g=sumG/sz;
    ret.b=sumB/sz;

    return ret;
}

color FindNeededColor(int x1,int y1,int x2,int y2,color c)
{
    int i,j;
    int sumR=0,sumG=0,sumB=0;
    color ret;
    int sz=(x2-x1+1)*(y2-y1+1);

    for (i=x1;i<=x2;i++)
    {
        for (j=y1;j<=y2;j++)
        {
            sumR+=goal[i][j].r;
            sumG+=goal[i][j].g;
            sumB+=goal[i][j].b;
        }
    }

    ret.r=sumR/sz;
    ret.r+=(ret.r-c.r);

    ret.g=sumG/sz;
    ret.g+=(ret.g-c.g);

    ret.b=sumB/sz;
    ret.b+=(ret.b-c.b);

    return ret;
}

Double GetDiff(int x1,int y1,int x2,int y2)
{
    int i,j;
    Double ans=0.0;

    for (i=x1;i<=x2;i++)
    {
        for (j=y1;j<=y2;j++)
        {
            ans+=DoubleD(pic[i][j],goal[i][j]);
        }
    }

    return ans;
}

///Move

void MakeAMove(int x1,int y1,int x2,int y2,int h,int w)
{
    int i,j;
    move he;

    for (i=0;i<h;i++)
    {
        for (j=0;j<w;j++)
        {
            pic[x1+i][y1+j]=Mix( pic[x1+i][y1+j] , pic[x2+i][y2+j] );
        }
    }

    he.x1=x1;
    he.y1=y1;
    he.x2=x2;
    he.y2=y2;
    he.h=h;
    he.w=w;

    Moves.push_back(he);

    return;
}

///

int MIN(int a,int b)
{
    if (a<b)
    return a;
    else
    return b;
}

int MAX(int a,int b)
{
    if (a>b)
    return a;
    else
    return b;
}

bool Compatible(int x1,int y1,int x2,int y2,int h,int w)
{
    if ( MIN(x1,x2)+h-1<MAX(x1,x2) || MIN(y1,y2)+w-1<MAX(y1,y2) )
    return true;
    else
    return false;
}

void Take(int x1,int y1,int x2,int y2)
{
    int i,j;

    for (i=x1;i<=x2;i++)
    {
        for (j=y1;j<=y2;j++)
        {
            taken[i][j]=true;
        }
    }

    return;
}

bool SortR(rect a,rect b)
{
    return a.diff>b.diff;
}

long long actions=0;

void GetDone(int h,int w)
{
    int i,j;
    int mindif,curdif;
    int chosen;

    L=0;
    memset(taken,false,sizeof(taken));

    for (i=1;i<=n-h+1;i++)
    {
        for (j=1;j<=m-w+1;j++)
        {
            if (taken[i][j])
            continue;

            if ( SameColor(i,j,i+h-1,j+w-1) )
            {
                L++;
                rects[L].x=i;
                rects[L].y=j;
                rects[L].c=FindColor(i,j,i+h-1,j+w-1);
                rects[L].need=FindNeededColor(i,j,i+h-1,j+w-1,rects[L].c);
                rects[L].diff=GetDiff(i,j,i+h-1,j+w-1);

                Take(i,j,i+h-1,j+w-1);
            }
        }
    }

    sort(rects+1,rects+1+L,SortR);

    for (i=1;i<=L/DV;i++)
    {
        if (!TimeIsOK())
        break;

        mindif=INF;
        for (j=1;j<=L;j++)
        {
            actions++;

            if (!Compatible(rects[i].x,rects[i].y,rects[j].x,rects[j].y,h,w))
            continue;

            curdif=IntD( rects[i].need,rects[j].c );

            if (curdif<mindif)
            {
                mindif=curdif;
                chosen=j;
            }
        }

        if (mindif>=IntD( rects[i].need,rects[i].c ))
        continue;

        MakeAMove(rects[i].x,rects[i].y,rects[chosen].x,rects[chosen].y,h,w);
        rects[i].c=FindColor(rects[i].x,rects[i].y,rects[i].x+h-1,rects[i].y+w-1);

        if (Moves.size()==k)
        break;
    }
}

void PrintMoves()
{
    int i;

    printf("%d\n",(int)BestMoves.size());

    for (i=0;i<BestMoves.size();i++)
    {
        printf("%d %d %d %d %d %d\n",BestMoves[i].x1-1,BestMoves[i].y1-1,BestMoves[i].x2-1,BestMoves[i].y2-1,BestMoves[i].h,BestMoves[i].w);
    }

    return;
}

void Make_Components()
{
    int i,j;

    memset(TFO,false,sizeof(TFO));
    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            if (!TFO[i][j])
            {
                ctr++;
                pattern=pic[i][j];
                MarkBFS(i,j);
            }
        }
    }

    memset(TFO,false,sizeof(TFO));
    ctr=0;
    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            if (!TFO[i][j])
            {
                ctr++;
                pattern=goal[i][j];
                MarkBFS2(i,j);
            }
        }
    }

    return;
}

Double Eval()
{
    return GetDiff(1,1,n,m);
}
Double BestValue=-2.0;
Double CurValue;

void GetMoves()
{
    int i;

    BestMoves.clear();

    for (i=0;i<(int)Moves.size();i++)
    {
        BestMoves.push_back(Moves[i]);
    }

    return;
}

void RestorePic()
{
    int i,j;

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            pic[i][j]=inp[i][j];
        }
    }

    return;
}

int main()
{
    freopen("transformation.in","r",stdin);
    freopen("transformation.out","w",stdout);
    //freopen("mytask.in","r",stdin);

    int i,j;
    int large=0;
    int sz1,sz2;
    int minicheck=0;
    ///Double First;

    scanf("%d %d %d",&n,&m,&k);

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            scanf("%d",&pic[i][j].r);
        }
    }

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            scanf("%d",&pic[i][j].g);
        }
    }

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            scanf("%d",&pic[i][j].b);
        }
    }

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            inp[i][j]=pic[i][j];
        }
    }

    ///

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            scanf("%d",&goal[i][j].r);
        }
    }

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            scanf("%d",&goal[i][j].g);
        }
    }

    for (i=1;i<=n;i++)
    {
        for (j=1;j<=m;j++)
        {
            scanf("%d",&goal[i][j].b);
        }
    }

    ///Components

    for (i=1;i<=1000;i++,AM+=5000)
    {
        Make_Components();

        sz1=64;
        sz2=64;
        minicheck=1;
        while(TimeIsOK() && (int)Moves.size()<k)
        {
            if (minicheck==DV-1)
            GetDone(sz1,sz2);
            else
            GetDone(sz2,sz1);

            Make_Components();

            if (minicheck<DV)
            {
                minicheck++;
                continue;
            }

            minicheck=1;

            if (sz1==sz2)
            {
                if (sz1>4)
                {
                    sz2/=2;
                }
                else
                {
                    sz1--;
                    sz2--;
                }

                if (sz1==0)
                {
                    sz1=1;
                    sz2=1;
                }
            }
            else
            {
                sz1/=2;
            }
        }

        CurValue=Eval();

        ///if (i==1)
        ///First=CurValue;

        //printf("%.2f\n",(double)CurValue);

        if (CurValue<BestValue || BestValue<-1.0)
        {
            BestValue=CurValue;
            GetMoves();
        }

        Moves.clear();
        RestorePic();

        if (!TimeIsOK())
        break;
    }

    PrintMoves();
    //printf("%.6f\n",(double)BestValue);

    return 0;
}
